Code

i18n: git-bisect echo + eval_gettext message
[git.git] / git-bisect.sh
1 #!/bin/sh
3 USAGE='[help|start|bad|good|skip|next|reset|visualize|replay|log|run]'
4 LONG_USAGE='git bisect help
5         print this long help message.
6 git bisect start [<bad> [<good>...]] [--] [<pathspec>...]
7         reset bisect state and start bisection.
8 git bisect bad [<rev>]
9         mark <rev> a known-bad revision.
10 git bisect good [<rev>...]
11         mark <rev>... known-good revisions.
12 git bisect skip [(<rev>|<range>)...]
13         mark <rev>... untestable revisions.
14 git bisect next
15         find next bisection to test and check it out.
16 git bisect reset [<commit>]
17         finish bisection search and go back to commit.
18 git bisect visualize
19         show bisect status in gitk.
20 git bisect replay <logfile>
21         replay bisection log.
22 git bisect log
23         show bisect log.
24 git bisect run <cmd>...
25         use <cmd>... to automatically bisect.
27 Please use "git help bisect" to get the full man page.'
29 OPTIONS_SPEC=
30 . git-sh-setup
31 . git-sh-i18n
32 require_work_tree
34 _x40='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
35 _x40="$_x40$_x40$_x40$_x40$_x40$_x40$_x40$_x40"
37 bisect_autostart() {
38         test -s "$GIT_DIR/BISECT_START" || {
39                 (
40                         gettext "You need to start by \"git bisect start\"" &&
41                         echo
42                 ) >&2
43                 if test -t 0
44                 then
45                         echo >&2 -n 'Do you want me to do it for you [Y/n]? '
46                         read yesno
47                         case "$yesno" in
48                         [Nn]*)
49                                 exit ;;
50                         esac
51                         bisect_start
52                 else
53                         exit 1
54                 fi
55         }
56 }
58 bisect_start() {
59         #
60         # Verify HEAD.
61         #
62         head=$(GIT_DIR="$GIT_DIR" git symbolic-ref -q HEAD) ||
63         head=$(GIT_DIR="$GIT_DIR" git rev-parse --verify HEAD) ||
64         die "Bad HEAD - I need a HEAD"
66         #
67         # Check if we are bisecting.
68         #
69         start_head=''
70         if test -s "$GIT_DIR/BISECT_START"
71         then
72                 # Reset to the rev from where we started.
73                 start_head=$(cat "$GIT_DIR/BISECT_START")
74                 git checkout "$start_head" -- || exit
75         else
76                 # Get rev from where we start.
77                 case "$head" in
78                 refs/heads/*|$_x40)
79                         # This error message should only be triggered by
80                         # cogito usage, and cogito users should understand
81                         # it relates to cg-seek.
82                         [ -s "$GIT_DIR/head-name" ] &&
83                                 die "won't bisect on seeked tree"
84                         start_head="${head#refs/heads/}"
85                         ;;
86                 *)
87                         die "Bad HEAD - strange symbolic ref"
88                         ;;
89                 esac
90         fi
92         #
93         # Get rid of any old bisect state.
94         #
95         bisect_clean_state || exit
97         #
98         # Check for one bad and then some good revisions.
99         #
100         has_double_dash=0
101         for arg; do
102             case "$arg" in --) has_double_dash=1; break ;; esac
103         done
104         orig_args=$(git rev-parse --sq-quote "$@")
105         bad_seen=0
106         eval=''
107         while [ $# -gt 0 ]; do
108             arg="$1"
109             case "$arg" in
110             --)
111                 shift
112                 break
113                 ;;
114             *)
115                 rev=$(git rev-parse -q --verify "$arg^{commit}") || {
116                     test $has_double_dash -eq 1 &&
117                         die "'$arg' does not appear to be a valid revision"
118                     break
119                 }
120                 case $bad_seen in
121                 0) state='bad' ; bad_seen=1 ;;
122                 *) state='good' ;;
123                 esac
124                 eval="$eval bisect_write '$state' '$rev' 'nolog'; "
125                 shift
126                 ;;
127             esac
128         done
130         #
131         # Change state.
132         # In case of mistaken revs or checkout error, or signals received,
133         # "bisect_auto_next" below may exit or misbehave.
134         # We have to trap this to be able to clean up using
135         # "bisect_clean_state".
136         #
137         trap 'bisect_clean_state' 0
138         trap 'exit 255' 1 2 3 15
140         #
141         # Write new start state.
142         #
143         echo "$start_head" >"$GIT_DIR/BISECT_START" &&
144         git rev-parse --sq-quote "$@" >"$GIT_DIR/BISECT_NAMES" &&
145         eval "$eval" &&
146         echo "git bisect start$orig_args" >>"$GIT_DIR/BISECT_LOG" || exit
147         #
148         # Check if we can proceed to the next bisect state.
149         #
150         bisect_auto_next
152         trap '-' 0
155 bisect_write() {
156         state="$1"
157         rev="$2"
158         nolog="$3"
159         case "$state" in
160                 bad)            tag="$state" ;;
161                 good|skip)      tag="$state"-"$rev" ;;
162                 *)              die "Bad bisect_write argument: $state" ;;
163         esac
164         git update-ref "refs/bisect/$tag" "$rev" || exit
165         echo "# $state: $(git show-branch $rev)" >>"$GIT_DIR/BISECT_LOG"
166         test -n "$nolog" || echo "git bisect $state $rev" >>"$GIT_DIR/BISECT_LOG"
169 is_expected_rev() {
170         test -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
171         test "$1" = $(cat "$GIT_DIR/BISECT_EXPECTED_REV")
174 check_expected_revs() {
175         for _rev in "$@"; do
176                 if ! is_expected_rev "$_rev"; then
177                         rm -f "$GIT_DIR/BISECT_ANCESTORS_OK"
178                         rm -f "$GIT_DIR/BISECT_EXPECTED_REV"
179                         return
180                 fi
181         done
184 bisect_skip() {
185         all=''
186         for arg in "$@"
187         do
188             case "$arg" in
189             *..*)
190                 revs=$(git rev-list "$arg") || die "Bad rev input: $arg" ;;
191             *)
192                 revs=$(git rev-parse --sq-quote "$arg") ;;
193             esac
194             all="$all $revs"
195         done
196         eval bisect_state 'skip' $all
199 bisect_state() {
200         bisect_autostart
201         state=$1
202         case "$#,$state" in
203         0,*)
204                 die "Please call 'bisect_state' with at least one argument." ;;
205         1,bad|1,good|1,skip)
206                 rev=$(git rev-parse --verify HEAD) ||
207                         die "Bad rev input: HEAD"
208                 bisect_write "$state" "$rev"
209                 check_expected_revs "$rev" ;;
210         2,bad|*,good|*,skip)
211                 shift
212                 eval=''
213                 for rev in "$@"
214                 do
215                         sha=$(git rev-parse --verify "$rev^{commit}") ||
216                                 die "Bad rev input: $rev"
217                         eval="$eval bisect_write '$state' '$sha'; "
218                 done
219                 eval "$eval"
220                 check_expected_revs "$@" ;;
221         *,bad)
222                 die "'git bisect bad' can take only one argument." ;;
223         *)
224                 usage ;;
225         esac
226         bisect_auto_next
229 bisect_next_check() {
230         missing_good= missing_bad=
231         git show-ref -q --verify refs/bisect/bad || missing_bad=t
232         test -n "$(git for-each-ref "refs/bisect/good-*")" || missing_good=t
234         case "$missing_good,$missing_bad,$1" in
235         ,,*)
236                 : have both good and bad - ok
237                 ;;
238         *,)
239                 # do not have both but not asked to fail - just report.
240                 false
241                 ;;
242         t,,good)
243                 # have bad but not good.  we could bisect although
244                 # this is less optimum.
245                 (
246                         gettext "Warning: bisecting only with a bad commit." &&
247                         echo
248                 ) >&2
249                 if test -t 0
250                 then
251                         printf >&2 'Are you sure [Y/n]? '
252                         read yesno
253                         case "$yesno" in [Nn]*) exit 1 ;; esac
254                 fi
255                 : bisect without good...
256                 ;;
257         *)
258                 THEN=''
259                 test -s "$GIT_DIR/BISECT_START" || {
260                         echo >&2 'You need to start by "git bisect start".'
261                         THEN='then '
262                 }
263                 echo >&2 'You '$THEN'need to give me at least one good' \
264                         'and one bad revisions.'
265                 echo >&2 '(You can use "git bisect bad" and' \
266                         '"git bisect good" for that.)'
267                 exit 1 ;;
268         esac
271 bisect_auto_next() {
272         bisect_next_check && bisect_next || :
275 bisect_next() {
276         case "$#" in 0) ;; *) usage ;; esac
277         bisect_autostart
278         bisect_next_check good
280         # Perform all bisection computation, display and checkout
281         git bisect--helper --next-all
282         res=$?
284         # Check if we should exit because bisection is finished
285         test $res -eq 10 && exit 0
287         # Check for an error in the bisection process
288         test $res -ne 0 && exit $res
290         return 0
293 bisect_visualize() {
294         bisect_next_check fail
296         if test $# = 0
297         then
298                 if test -n "${DISPLAY+set}${SESSIONNAME+set}${MSYSTEM+set}${SECURITYSESSIONID+set}" &&
299                    type gitk >/dev/null 2>&1; then
300                         set gitk
301                 else
302                         set git log
303                 fi
304         else
305                 case "$1" in
306                 git*|tig) ;;
307                 -*)     set git log "$@" ;;
308                 *)      set git "$@" ;;
309                 esac
310         fi
312         eval '"$@"' --bisect -- $(cat "$GIT_DIR/BISECT_NAMES")
315 bisect_reset() {
316         test -s "$GIT_DIR/BISECT_START" || {
317                 gettext "We are not bisecting."; echo
318                 return
319         }
320         case "$#" in
321         0) branch=$(cat "$GIT_DIR/BISECT_START") ;;
322         1) git rev-parse --quiet --verify "$1^{commit}" > /dev/null ||
323                die "'$1' is not a valid commit"
324            branch="$1" ;;
325         *)
326             usage ;;
327         esac
328         if git checkout "$branch" -- ; then
329                 bisect_clean_state
330         else
331                 die "Could not check out original HEAD '$branch'." \
332                                 "Try 'git bisect reset <commit>'."
333         fi
336 bisect_clean_state() {
337         # There may be some refs packed during bisection.
338         git for-each-ref --format='%(refname) %(objectname)' refs/bisect/\* |
339         while read ref hash
340         do
341                 git update-ref -d $ref $hash || exit
342         done
343         rm -f "$GIT_DIR/BISECT_EXPECTED_REV" &&
344         rm -f "$GIT_DIR/BISECT_ANCESTORS_OK" &&
345         rm -f "$GIT_DIR/BISECT_LOG" &&
346         rm -f "$GIT_DIR/BISECT_NAMES" &&
347         rm -f "$GIT_DIR/BISECT_RUN" &&
348         # Cleanup head-name if it got left by an old version of git-bisect
349         rm -f "$GIT_DIR/head-name" &&
351         rm -f "$GIT_DIR/BISECT_START"
354 bisect_replay () {
355         test "$#" -eq 1 || die "No logfile given"
356         test -r "$1" || die "cannot read $1 for replaying"
357         bisect_reset
358         while read git bisect command rev
359         do
360                 test "$git $bisect" = "git bisect" -o "$git" = "git-bisect" || continue
361                 if test "$git" = "git-bisect"; then
362                         rev="$command"
363                         command="$bisect"
364                 fi
365                 case "$command" in
366                 start)
367                         cmd="bisect_start $rev"
368                         eval "$cmd" ;;
369                 good|bad|skip)
370                         bisect_write "$command" "$rev" ;;
371                 *)
372                         die "?? what are you talking about?" ;;
373                 esac
374         done <"$1"
375         bisect_auto_next
378 bisect_run () {
379     bisect_next_check fail
381     while true
382     do
383       echo "running $@"
384       "$@"
385       res=$?
387       # Check for really bad run error.
388       if [ $res -lt 0 -o $res -ge 128 ]; then
389           echo >&2 "bisect run failed:"
390           echo >&2 "exit code $res from '$@' is < 0 or >= 128"
391           exit $res
392       fi
394       # Find current state depending on run success or failure.
395       # A special exit code of 125 means cannot test.
396       if [ $res -eq 125 ]; then
397           state='skip'
398       elif [ $res -gt 0 ]; then
399           state='bad'
400       else
401           state='good'
402       fi
404       # We have to use a subshell because "bisect_state" can exit.
405       ( bisect_state $state > "$GIT_DIR/BISECT_RUN" )
406       res=$?
408       cat "$GIT_DIR/BISECT_RUN"
410       if sane_grep "first bad commit could be any of" "$GIT_DIR/BISECT_RUN" \
411                 > /dev/null; then
412           (
413               gettext "bisect run cannot continue any more" &&
414               echo
415           ) >&2
416           exit $res
417       fi
419       if [ $res -ne 0 ]; then
420           (
421               eval_gettext "bisect run failed:
422 'bisect_state \$state' exited with error code \$res" &&
423               echo
424           ) >&2
425           exit $res
426       fi
428       if sane_grep "is the first bad commit" "$GIT_DIR/BISECT_RUN" > /dev/null; then
429           gettext "bisect run success"; echo
430           exit 0;
431       fi
433     done
436 bisect_log () {
437         test -s "$GIT_DIR/BISECT_LOG" || die "We are not bisecting."
438         cat "$GIT_DIR/BISECT_LOG"
441 case "$#" in
442 0)
443     usage ;;
444 *)
445     cmd="$1"
446     shift
447     case "$cmd" in
448     help)
449         git bisect -h ;;
450     start)
451         bisect_start "$@" ;;
452     bad|good)
453         bisect_state "$cmd" "$@" ;;
454     skip)
455         bisect_skip "$@" ;;
456     next)
457         # Not sure we want "next" at the UI level anymore.
458         bisect_next "$@" ;;
459     visualize|view)
460         bisect_visualize "$@" ;;
461     reset)
462         bisect_reset "$@" ;;
463     replay)
464         bisect_replay "$@" ;;
465     log)
466         bisect_log ;;
467     run)
468         bisect_run "$@" ;;
469     *)
470         usage ;;
471     esac
472 esac